Option Base 0
Option Default None
Option Explicit

'Save "nes.bas"

Const LATCH_PIN% = 9 ' GP6
Const CLOCK_PIN% = 10 ' GP7
Const DATA_PIN%  = 11 ' GP 8
Const PULSE_DURATION! = 0.012 ' 12 micro-seconds

SetPin LATCH_PIN%, Dout
SetPin CLOCK_PIN%, Dout
SetPin DATA_PIN%, Din

Pin(LATCH_PIN%) = 0
Pin(CLOCK_PIN%) = 0

Dim i%, out%

Do
  Pulse LATCH_PIN%, PULSE_DURATION!
  out% = &h0

  For i% = 0 To 7
    If Not Pin(DATA_PIN%) Then out% = out% Or 2^i%
    Pulse CLOCK_PIN%, PULSE_DURATION!
  Next

  If out% <> 0 Then
    If out% And &h01 Then Print "A ";
    If out% And &h02 Then Print "B ";
    If out% And &h04 Then Print "Select ";
    If out% And &h08 Then Print "Start ";
    If out% And &h10 Then Print "Up ";
    If out% And &h20 Then Print "Down ";
    If out% And &h40 Then Print "Left ";
    If out% And &h80 Then Print "Right ";
  Else
    Print ". ";
  EndIf
Loop


